﻿import com.audiopackage.GSound;

/*
* class GBuffer
* Kind of workaround to avoid crashing flash
* It stores a reference of its own instance with
* a reference of a GSound Instance to get the onSoundComplete
* Event intact even when the instance is created local
*/

class com.audiopackage.GBuffer
{
	static var instances: Array = new Array();
	static var count: Number = 0;
	
	static function clear( gBuffer: GBuffer )
	{
		delete instances[ gBuffer.id ];
	}
	
	private var buffer: GSound;
	private var id: Number;
	
	function GBuffer( gSound: GSound )
	{
		buffer = gSound;
		
		instances[id = count++] = this;
	}
}